package  
{
	import org.flixel.*;
	/**
	 * ...
	 * @author Simon Davies
	 */
	public class BlowStream extends FlxGroup
	{
		
		private var _selected:Boolean;
		
		[Embed(source="../assets/sounds/select.mp3")]private var selectSound:Class;
		[Embed(source="../assets/sounds/unselect.mp3")]private var unSelectSound:Class;
		
		public function set selected(value:Boolean):void {
			if (value == true) {
				FlxG.play(selectSound);
				selectionBox.visible = true;
				descText.exists = true;
			}
			else {
				if (_selected) {
					FlxG.play(unSelectSound);
				}
				selectionBox.visible = false;
				descText.exists = false;
			}
			_selected = value;
		}
		
		public function get selected():Boolean {
			return _selected;
		}
		
		private var enabled:Boolean;
		
		public var x:Number;
		public var y:Number;
		
		[Embed(source="../assets/selection.png")] private var selectImage:Class;
		
		private var selectionBox:FlxSprite;
		
		[Embed(source="../assets/spawner.png")] private var spawnerImage:Class;
		private var spawnerSprite:FlxSprite;
		
		[Embed(source="../assets/type_blow.png")] private var spawnerImageType:Class;
		private var spawnerTypeSprite:FlxSprite
		
		[Embed(source="../assets/line.png")] private var streamBeamImage:Class;
		[Embed(source="../assets/line2.png")] private var vectorLineImage:Class;
		
		private var vector:FlxSprite;
		private var streamBeam:FlxSprite;
		
		public var angle:Number;
		
		private var descText:FlxText;
		
		public function BlowStream(x:Number, y:Number) 
		{
			super();
			
			this.x = x;
			this.y = y;
			
			descText = new FlxText(x + 64, y - 64, 128);
			
			angle = 90;
				
			streamBeam = new FlxSprite(x, y + 32 - 256,streamBeamImage);
			streamBeam.angle = angle;
			streamBeam.scale = new FlxPoint(1, 4);
			streamBeam.color = 0xff0000ff;
			add(streamBeam);
			
			vector = new FlxSprite(x + 28, y + 32 - 32,vectorLineImage);
			vector.angle = angle;
			vector.scale = new FlxPoint(1, 2);
			vector.color = 0xff00aaff;
			add(vector);
			
			spawnerSprite = new FlxSprite(this.x, this.y);
			spawnerSprite.loadGraphic(spawnerImage);
			spawnerSprite.angularVelocity = 250;
			add(spawnerSprite);
			
			selectionBox = new FlxSprite(x,y,selectImage);
			add(selectionBox);
			
			spawnerTypeSprite = new FlxSprite(x + spawnerSprite.width / 4 , y + + spawnerSprite.height / 4);
			
			spawnerTypeSprite.loadGraphic(spawnerImageType);
			
			spawnerSprite.color = 0xff0044aa;
			descText.text = "Blow Stream\n\nGusts of air from this\ncan blow creatures around dangerous objects."
			
			add(spawnerTypeSprite);
			
			add(descText);
			descText.exists = false;
			
			selected = false;
		}
		
		override public function update():void {
			super.update();
			
			// Mouse selection
			if (FlxG.mouse.justPressed()) {
				if(!selected && FlxG.mouse.x > x && FlxG.mouse.y > y && FlxG.mouse.x < x + spawnerSprite.width && FlxG.mouse.y < y + spawnerSprite.height) {
					selected = true;
				}
				else {
					selected = false;
				}
			}
			
			// if selected, do mouse pointing stuff
			if (selected) {
				var mousePoint:FlxPoint = FlxG.mouse.getWorldPosition();
				
				angle = FlxU.getAngle(new FlxPoint(x, y), mousePoint);
				
				vector.angle = angle;
				streamBeam.angle = angle;
			}
		}
		
	}

}