package  
{
	import org.flixel.*
	/**
	 * ...
	 * @author Simon Davies
	 */
	public class LevelEnd extends FlxGroup
	{
		
		[Embed(source = "../assets/end.png")] protected var endImage:Class;
		
		public var x:Number;
		public var y:Number;
		
		private var portal:FlxSprite;
		private var conditionImage:FlxSprite;
		private var progressText:FlxText;
		
		public var requirement:String;
		
		private var count:uint;
		private var goal:uint;
		
		private var timer:Number;
		private var timerReset:Number;
		
		public function LevelEnd(x:Number, y:Number, species:String) 
		{
			this.x = x;
			this.y = y;
			
			timer = 0;
			timerReset = 2;
			
			requirement = species;
			
			count = 0;
			goal = 5;
			
			portal = new Portal(x, y, endImage, this);
			
			portal.width = portal.width * 0.5;
			portal.height = portal.height * 0.5;
			portal.centerOffsets();
			portal.angularVelocity = 100;
			
			conditionImage = new FlxSprite(x - 16, y);
			
			// Set sprite for the icon
			if (species == "Fish") {
				conditionImage.loadGraphic(Animal.fishImage);
			}
			else if (species == "Lizard") {
				conditionImage.loadGraphic(Animal.lizardImage);
			}			
			else if (species == "Bird") {
				conditionImage.loadGraphic(Animal.birdImage);
			}				
			else if (species == "Sheep") {
				conditionImage.loadGraphic(Animal.sheepImage);
			}			
			else if (species == "Newt") {
				conditionImage.loadGraphic(Animal.newtImage);
				conditionImage.centerOffsets();
				conditionImage.x += 16;
				conditionImage.y += 8;
			}
			
			conditionImage.color = 0xffff0000;
			conditionImage.angularVelocity = 20;
			
			progressText = new FlxText(x + portal.width / 2, y + portal.height, 32, count + "/" + goal);
			progressText.size = 14;
			
			add(portal);
			add(conditionImage);
			add(progressText);
		}
		
		public function increment():void {
			timer = 0;
			if(count < goal){
				count++;
				progressText.text = count + "/" + goal;
			
				// Completed
				if (count >= goal) {
					conditionImage.color = 0xff00ff00;
				}
			}
		}
		
		public function getCompleted():Boolean {
			return count >= goal;
		}
		
		override public function update():void {
			super.update();
			
			timer += FlxG.elapsed;
			// Progress reset if not had anymore creatures in a while
			if (timer > timerReset) {
				timer = 0;
				count = 0;
				progressText.text = count + "/" + goal;
				conditionImage.color = 0xffff0000;
			}
		}
		
	}

}