package  
{
	import org.flixel.*;
	/**
	 * ...
	 * @author Simon Davies
	 */
	public class MenuState extends FlxState
	{
		
		[Embed(source="../assets/title.png")]private var title:Class;
		[Embed(source = "../assets/startgame.png")]private var startGame:Class;
		
		private var blogButton:FlxButton;
		private var newGameButton:FlxButton;
		
		private var aboutText:FlxText;
		
		override public function create():void
		{
			FlxG.mouse.show();
			
			var textWidth:uint = 180;
			
			var titleSprite:FlxSprite = new FlxSprite(0, 0, title);
			add(titleSprite);
			
			// New game button
			newGameButton = new FlxButton(FlxG.width / 2 - 128, 240, "Start Game", onNewGame);
			newGameButton.loadGraphic(startGame);
			
			add(newGameButton);
			
			// Blog button
			blogButton = new FlxButton(FlxG.width - 128, FlxG.height - 64, "Visit blog", onShrimpCave);
			blogButton.scale.x = blogButton.scale.y = 1.5;
			add(blogButton);
			
			aboutText = new FlxText(0, FlxG.height - 64, 256,
			"A game for Ludum Dare #24\nTheme: Evolution");
			aboutText.size = 10;
			
			add(aboutText);
		}
		
		private function onShrimpCave():void
		{
			FlxU.openURL("http://www.shrimpcave.com");
		}		
		
		private function onNewGame():void
		{
			FlxG.switchState(new LevelBase());
		}
		
	}

}